searchNodes=[{"doc":"Integration with Auth0 to authorize m2m communication","ref":"BridgeEx.Auth0AuthorizationProvider.html","title":"BridgeEx.Auth0AuthorizationProvider","type":"module"},{"doc":"","ref":"BridgeEx.Auth0AuthorizationProvider.html#authorization_headers/1","title":"BridgeEx.Auth0AuthorizationProvider.authorization_headers/1","type":"function"},{"doc":"Main module to be used to implement graphql bridges.","ref":"BridgeEx.Graphql.html","title":"BridgeEx.Graphql","type":"module"},{"doc":"Documentation for BridgeEx .","ref":"BridgeEx.Graphql.Client.html","title":"BridgeEx.Graphql.Client","type":"module"},{"doc":"Calls a GraphQL endpoint Options :options - HTTPoison options :headers - HTTPoison headers :max_attempts - Defines number of retries before returning error","ref":"BridgeEx.Graphql.Client.html#call/6","title":"BridgeEx.Graphql.Client.call/6","type":"function"},{"doc":"formats a GraphQL query response to make it Absinthe compliant","ref":"BridgeEx.Graphql.Client.html#format_response/1","title":"BridgeEx.Graphql.Client.format_response/1","type":"function"},{"doc":"","ref":"BridgeEx.Graphql.Client.html#t:bridge_response/0","title":"BridgeEx.Graphql.Client.bridge_response/0","type":"type"},{"doc":"This defines an adapter that supports GraphQL query documents in their conventional (in JS) camelcase notation, while allowing the schema to be defined using conventional (in Elixir) underscore (snakecase) notation, and tranforming the names as needed for lookups, results, and error messages. For example, this document: { myUser : createUser ( userId : 2 ) { firstName lastName } } Would map to an internal schema that used the following names: create_user instead of createUser user_id instead of userId first_name instead of firstName last_name instead of lastName Likewise, the result of executing this (camelcase) query document against our (snakecase) schema would have its names transformed back into camelcase on the way out: %{ data : %{ &quot;myUser&quot; =&gt; %{ &quot;firstName&quot; =&gt; &quot;Joe&quot; , &quot;lastName&quot; =&gt; &quot;Black&quot; } } } Note variables are a client-facing concern (they may be provided as parameters), so variable names should match the convention of the query document (eg, camelCase).","ref":"BridgeEx.Graphql.LanguageConventions.html","title":"BridgeEx.Graphql.LanguageConventions","type":"module"},{"doc":"Callback implementation for Absinthe.Adapter.to_external_name/2 .","ref":"BridgeEx.Graphql.LanguageConventions.html#to_external_name/2","title":"BridgeEx.Graphql.LanguageConventions.to_external_name/2","type":"function"},{"doc":"Converts a camelCase to snake_case iex&gt; to_internal_name(&quot;test&quot;, :read) &quot;test&quot; iex&gt; to_internal_name(&quot;testTTT&quot;, :read) &quot;test_t_t_t&quot; iex&gt; to_internal_name(&quot;testTest&quot;, :read) &quot;test_test&quot; iex&gt; to_internal_name(&quot;testTest1&quot;, :read) &quot;test_test_1&quot; iex&gt; to_internal_name(&quot;testTest11&quot;, :read) &quot;test_test_11&quot; iex&gt; to_internal_name(&quot;testTest11Pippo&quot;, :read) &quot;test_test_11_pippo&quot; iex&gt; to_internal_name(&quot;camelCase23Snake4344&quot;, :read) &quot;camel_case_23_snake_4344&quot;","ref":"BridgeEx.Graphql.LanguageConventions.html#to_internal_name/2","title":"BridgeEx.Graphql.LanguageConventions.to_internal_name/2","type":"function"},{"doc":"Misc utils for handling Graphql requests/responses.","ref":"BridgeEx.Graphql.Utils.html","title":"BridgeEx.Graphql.Utils","type":"module"},{"doc":"","ref":"BridgeEx.Graphql.Utils.html#decode_http_response/2","title":"BridgeEx.Graphql.Utils.decode_http_response/2","type":"function"},{"doc":"","ref":"BridgeEx.Graphql.Utils.html#normalize_inner_fields/1","title":"BridgeEx.Graphql.Utils.normalize_inner_fields/1","type":"function"},{"doc":"","ref":"BridgeEx.Graphql.Utils.html#parse_response/1","title":"BridgeEx.Graphql.Utils.parse_response/1","type":"function"},{"doc":"","ref":"BridgeEx.Graphql.Utils.html#retry/3","title":"BridgeEx.Graphql.Utils.retry/3","type":"function"},{"doc":"","ref":"BridgeEx.Graphql.Utils.html#t:client_response/0","title":"BridgeEx.Graphql.Utils.client_response/0","type":"type"},{"doc":"","ref":"BridgeEx.Graphql.Utils.html#t:graphql_response/0","title":"BridgeEx.Graphql.Utils.graphql_response/0","type":"type"},{"doc":"Copyright (c) 2020 Prima.it Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"A library to build bridges to other services (actually only graphql ones are supported).","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"A GraphQL bridge Define a behaviour with the queries/mutations you're going to need for the bridge: defmodule MyApp.SomeService do @moduledoc &quot;&quot;&quot; Bridge definition for SomeService &quot;&quot;&quot; @callback my_cool_query ( any ( ) ) :: { :ok , map ( ) }   | { :error , any ( ) } end Implement the behaviour: defmodule MyApp.SomeServiceBridge do @moduledoc &quot;&quot;&quot; Bridge implementation for SomeService behaviour. &quot;&quot;&quot; @behaviour MyApp.SomeService use BridgeEx.Graphql , [ # mandatory settings endpoint : &quot;http://some_service.example.com&quot; , # optional settings (with defaults) http_headers : %{ &quot;User-Agent&quot; =&gt; &quot;microservice-myapp/myapp-version&quot; , &quot;Content-type&quot; =&gt; &quot;application/json&quot; , &quot;X-Client-Id&quot; =&gt; &quot;myapp&quot; , &quot;X-Client-Secret&quot; =&gt; &quot;myapp_secret&quot; } , http_options : [ timeout : 1_000 , recv_timeout : 16_000 ] , max_attempts : 1 , encode_variables : false , format_response : true # formats keys from CamelCase to snake_case ] def my_cool_query ( %{ } = variables ) do call ( &quot;a graphql query or mutation&quot; , variables ) # or, if you need more granularity (ex: different endpoint or options): # BridgeEx.Graphql.Client.call( # &quot;https://another-url.com/graphql&quot;, # &quot;graphql query or mutation&quot;, # variables, # encode_variables: false, # [timeout: 1_000, recv_timeout: 16_000], # %{ # &quot;Some-Header&quot; =&gt; &quot;some-value&quot;, # }, # 1 # ) end end You can now use your bridge module: MyApp.SomeServiceBridge . my_cool_query ( %{ var : 1 } ) As a good practice, if you want to mock your bridge for testing, you should implement another module: defmodule MyApp.SomeServiceBridgeMock do @behaviour MyApp.SomeService alias BridgeEx.Graphql.Utils def my_cool_query ( %{ } = variables ) do File . read! ( &quot;some_mock_file.json&quot; ) |&gt; Json . decode! ( keys : :atoms ) |&gt; Utils . parse_response ( ) # required to parse data # |&gt; BridgeEx.Graphql.Client.format_response() # optional, if you want to format response end end You can now set the right module in your config/* directory: config :my_app , :some_service_bridge , MyApp.SomeServiceBridge # or config :my_app , :some_service_bridge , MyApp.SomeServiceBridgeMock And use it in your app from configuration: @some_service Application . compile_env! ( :my_app , :some_service_bridge ) # ... @some_service . my_cool_query ( %{ var : 2 } ) See example directory for an implementation, it also works in dev and test environments. Authenticating calls via Auth0 bridge_ex supports authentication of machine-to-machine calls via Auth0, through the prima_auth0_ex library. To use this feature, simply configure your bridge with the audience of the target service: use BridgeEx.Graphql , [ endpoint : &quot;...&quot; , auth0 : [ enabled : true , audience : &quot;target_audience&quot; ] ] For this feature to work, your config.exs must be updated with the configuration for the prima_auth0_ex library. You can refer to the library's README for more information on the supported configuration.","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"mix deps.get &amp;&amp; mix test","ref":"readme.html#development","title":"Overview - Development","type":"extras"},{"doc":"The package can be installed by adding bridge_ex to your list of dependencies in mix.exs : def deps do [ { :bridge_ex , &quot;~&gt; 0.4.0&quot; } ] end","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Copyright (c) 2020 Prima.it This work is free. You can redistribute it and/or modify it under the terms of the MIT License. See the LICENSE.md file for more details.","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]